summaryrefslogtreecommitdiff
path: root/.config/login.d/02_xdg_runtime_dir.sh
diff options
context:
space:
mode:
authorLuke Shumaker <lukeshu@sbcglobal.net>2015-04-13 17:10:00 -0400
committerLuke Shumaker <lukeshu@sbcglobal.net>2015-04-13 17:10:00 -0400
commit39db29c39dcca6d47fbc56dffd8c0c7bf63beb51 (patch)
treec769eba9bb2da4cf6eca0421992736841bf8f8d6 /.config/login.d/02_xdg_runtime_dir.sh
parentf181c08119e7bf00ce6520331afb737321f350ad (diff)
parent39c0d7a5c7538350e96fc135147f56cdb7d45093 (diff)
Merge remote-tracking branch 'origin/master'
Diffstat (limited to '.config/login.d/02_xdg_runtime_dir.sh')
-rw-r--r--.config/login.d/02_xdg_runtime_dir.sh28
1 files changed, 28 insertions, 0 deletions
diff --git a/.config/login.d/02_xdg_runtime_dir.sh b/.config/login.d/02_xdg_runtime_dir.sh
new file mode 100644
index 0000000..6d93359
--- /dev/null
+++ b/.config/login.d/02_xdg_runtime_dir.sh
@@ -0,0 +1,28 @@
+# This should be readable by /bin/sh
+
+# Set XDG_RUNTIME_DIR if we can
+if [ -z "$XDG_RUNTIME_DIR" ] && shopt -q login_shell && type flock &>/dev/null; then
+ _diy_xdg_runtime_login() {
+ export XDG_RUNTIME_DIR="$XDG_CACHE_HOME/xdg-runtime-dir/$HOSTNAME"
+ # There's a race condition here, between the `ln -s` and `flock`.
+ # But it's not like I'll be hammering a box with logins.
+ if [ ! -d "$XDG_RUNTIME_DIR" ]; then
+ local tmp="$(mktemp -d --tmpdir -- "${USER}@${HOSTNAME}-runtime.XXXXXXXXXX")"
+ mkdir -p -- "$XDG_CACHE_HOME/xdg-runtime-dir"
+ ln -sfT -- "$tmp" "$XDG_RUNTIME_DIR"
+ fi
+ if ! [ /dev/fd/7 -ef "$XDG_CACHE_HOME/xdg-runtime-dir/.lock" ]; then
+ exec 7>"$XDG_CACHE_HOME/xdg-runtime-dir/.lock"
+ if flock -sn 7; then
+ # Unfortunately this doesn't survive across exec(1).
+ trap _diy_xdg_runtime_logout EXIT
+ fi
+ fi
+ }
+ _diy_xdg_runtime_logout() {
+ if flock -xn 7; then
+ rm -rf -- "$(readlink "$XDG_RUNTIME_DIR")"
+ fi
+ }
+ _diy_xdg_runtime_login
+fi